CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

SliceSolid Method (ActiveX)

2023-1-4 00:53| 发布者: admin| 查看: 334| 评论: 0|来自: AutoCAD

摘要: 创建给定定义平面的三个点的 3DSolid 对象的切片。

创建给定定义平面的三个点的 3DSolid 对象的切片。

支持的平台:仅窗口

签名

工 务 局:

RetVal = object.SliceSolid(Point1, Point2, Point3, Negative)
对象

类型:3DSolid

此方法适用的对象。

要点1

访问:仅输入

类型:变体(双精度的三元素数组)

指定第一个点的 3D WCS 坐标。

要点2

访问:仅输入

类型:变体(双精度的三元素数组)

指定第二个点的 3D WCS 坐标。

要点3

访问:仅输入

类型:变体(双精度的三元素数组)

指定第三个点的 3D WCS 坐标。

阴性

访问:仅输入

类型:布尔

这指定是否返回位于平面负侧的实体部分。如果,则 AutoCAD 创建一个新对象,其中包含位于平面负法向侧的原始实体部分。True3DSolid

返回值(RetVal)

类型:3DSolid

生成的切片作为对象。3DSolid

言论

没有额外的评论。

例子

工 务 局:

Sub Example_SliceSolid()
    ' This example creates a box in model space.
    ' It then slices the box based on a plane
    ' defined by three points. The slice is returned
    ' as a 3Dsolid.
        
    Dim boxObj As Acad3DSolid
    Dim length As Double, width As Double, height As Double
    Dim center(0 To 2) As Double
    
    ' Define the box
    center(0) = 5#: center(1) = 5#: center(2) = 0
    length = 5#: width = 7: height = 10#
    
    ' Create the box (3DSolid) object in model space
    Set boxObj = ThisDrawing.ModelSpace.AddBox(center, length, width, height)
    
    ' Define the section plane with three points
    Dim slicePt1(0 To 2) As Double
    Dim slicePt2(0 To 2) As Double
    Dim slicePt3(0 To 2) As Double
    
    slicePt1(0) = 1.5: slicePt1(1) = 7.5: slicePt1(2) = 0
    slicePt2(0) = 1.5: slicePt2(1) = 7.5: slicePt2(2) = 10
    slicePt3(0) = 8.5: slicePt3(1) = 2.5: slicePt3(2) = 10
    
    ' slice the box
    Dim sliceObj As Acad3DSolid
    Set sliceObj = boxObj.SliceSolid(slicePt1, slicePt2, slicePt3, True)
    
    ' Change the viewing direction of the viewport
    Dim NewDirection(0 To 2) As Double
    NewDirection(0) = -1: NewDirection(1) = -1: NewDirection(2) = 1
    ThisDrawing.ActiveViewport.direction = NewDirection
    ThisDrawing.ActiveViewport = ThisDrawing.ActiveViewport
    ZoomAll
    
End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_SliceSolid()
    ;; This example creates a box in model space.
    ;; It then slices the box based on a plane
    ;; defined by three points. The slice is returned
    ;; as a 3Dsolid.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))
    
    ;; Define the box
    (setq center (vlax-3d-point 5 5 0)
          boxLength 5
	         boxWidth 7
	         boxHeight 10)
    
    ;; Create the box (3DSolid) object in model space
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq boxObj (vla-AddBox modelSpace center boxLength boxWidth boxHeight))
    
    ;; Define the section plane with three points
    (setq slicePt1 (vlax-3d-point 1.5 7.5 0)
          slicePt2 (vlax-3d-point 1.5 7.5 10)
          slicePt3 (vlax-3d-point 8.5 2.5 10))
    
    ;; slice the box
    (setq sliceObj (vla-SliceSolid boxObj slicePt1 slicePt2 slicePt3 :vlax-true))
    
    ;; Change the viewing direction of the viewport
    (setq NewDirection (vlax-3d-point -1 -1 1))
    (setq activeViewport (vla-get-ActiveViewport doc))
    (vla-put-Direction activeViewport NewDirection)
    (vla-put-ActiveViewport doc activeViewport)
    (vla-ZoomAll acadObj)
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-11 18:32

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部